# This Python file uses the following encoding: utf-8

# Important:
# You need to run the following command to generate the ui_form.py file
#     pyside6-uic form.ui -o ui_form.py, or
#     pyside2-uic form.ui -o ui_form.py

##################################################################################################
#Code Starts Here

import sys #for argv
from PySide6.QtWidgets import QApplication, QMainWindow
from PySide6.QtCore import Slot, QProcess
from ui_form import Ui_MainWindow


class MainWindow(QMainWindow):
    def __init__(self, parent=None):
        super(MainWindow, self).__init__()
        #super().__init__(parent)
        self.ui = Ui_MainWindow()
        self.ui.setupUi(self)

        self.setWindowTitle("QProcess Test")

        # set up the execute button
        self.ui.pb_execute.setText("Execute")
        self.ui.pb_execute.clicked.connect(self.execute)

    # Append a string in pte_status
    def updateStatus(self,s):
        self.ui.pte_status.appendPlainText(s)

    # Event handler for pb_execute.clicked
    @Slot()
    def execute(self):
        #command = "ls"
        #arguments = ["-al"]
        #command = "ssh"
        #arguments = ["me@192.168.2.159", "ls", "-al"]

        command = "ssh"
        arguments = [ "me@192.168.2.159" , "ping", "www.google.com"]

        print("Executing: " + command + " " + arguments[0])
        self.updateStatus("Executing: " + command + " " + arguments[0])
        self.process = QProcess()
        self.process.finished.connect(self.process_finished)
        self.process.readyReadStandardOutput.connect(self.handleStdout)
        self.process.readyReadStandardError.connect(self.handleStderr)
        self.process.start(command, arguments)

    def process_finished(self):
        print("Done executing.")
        self.updateStatus("Done Executing\n")

    def handleStdout(self):
        data = self.process.readAllStandardOutput()
        message = "Stdout:\n" + bytes(data).decode("utf8")
        print(message)
        self.updateStatus(message)

    def handleStderr(self):
        data = self.process.readAllStandardError()
        message = "Stdout:\n" + bytes(data).decode("utf8")
        print(message)
        self.updateStatus(message)


# main
if __name__ == "__main__":
    app = QApplication(sys.argv)
    myWindow = MainWindow()
    myWindow.show()
    print("Starting QProcess test...")
    myWindow.updateStatus("Starting QProcess test...\n")

    #run the main Qt loop
    sys.exit(app.exec())


